#### library ####
require "open-uri"
require "json"
def print2(x)
  print x
  print "\n"
  x
end
def http_req(u)
  open(u) {|f| f.read}
end
def encode2(call2)
  URI::encode(JSON.generate(call2))
end
$urls = ["https://a.totp.me:8443/prot",
         "https://b1.totp.me:18443/prot2",
         "https://b2.totp.me:28443/prot2",
         "https://b3.totp.me:38443/prot2",
         "https://b4.totp.me:48443/prot2"]
def fetch(urls, action, key, arg)
  if urls.empty?; raise Exception.new("could not connect to any servers"); end
  begin
    http_req(urls[0]+"?action="+action+"&key="+key+"&arg="+arg)
  rescue Exception
    fetch(urls.drop(1), action, key, arg)
  end
end
def make_client_msg(key, call2)
  fetch($urls, "make-client-msg", key, encode2(call2))
end
def decode_server_msg(key, msg, sid)
  sid2 = sid.to_i #nil.to_i = 0
  JSON.parse(fetch($urls[sid2,1], "decode-server-msg", key, msg))
end

####
REQS="totp:outstanding-reqs"
$reqfns={}
def push_outstanding_request_obs(session, oreq)
  x = session[REQS]
  if !x; x = session[REQS] = []; end
  x.push(oreq)
end
def push_outstanding_request(session, oreq)
  $reqfns[oreq[0]] = oreq
end
def remove_outstanding_request_obs(session, reqid)
  session[REQS].delete(session[REQS].assoc(reqid))
end
def remove_outstanding_request(session, reqid)
  $reqfns.delete(reqid)
end
$next_id = 0
#todo atomically
def next_req_id()
  $next_id = $next_id + 1
end
$key=nil
def set_key(k)
  $key = k
end
def call1(session, fn, u, h)
  reqid = next_req_id()
  oreq = [reqid, u, h]
  push_outstanding_request(session, oreq)
  make_client_msg($key, [reqid, fn, u])
end
def prov(s, u, h)
  call1(s, "prov", u, h)
end
def auth(s, u, h)
  call1(s, "auth", u, h)
end
#globals $ should be instance @, but that doesn't work in rails

def otp_response_handler
  res2 = decode_server_msg($key, params[:res], params[:sid])
  oreq = remove_outstanding_request(session, res2[0])
  oreq[2].call(self, oreq[1], res2[1] != [])
end

# rails in dev mode reloads files on every request. so can't use variables.
# files in lib aren't reloaded, so can use vars there
# for some reason, @next_id doesn't work, but $next_id does
